
package net.mcreator.cabinfever.client.screens;

import org.checkerframework.checker.units.qual.h;

import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.eventbus.api.EventPriority;
import net.minecraftforge.client.event.RenderGuiEvent;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.renderer.GameRenderer;
import net.minecraft.client.Minecraft;

import net.mcreator.cabinfever.procedures.CabinFeverHudShouldDisplayProcedure;
import net.mcreator.cabinfever.procedures.CabinFeverHudMeterTextProcedure;
import net.mcreator.cabinfever.procedures.CabinFeverHudIncreaseArrowProcedure;
import net.mcreator.cabinfever.procedures.CabinFeverHudDecreaseArrowProcedure;

import com.mojang.blaze3d.systems.RenderSystem;
import com.mojang.blaze3d.platform.GlStateManager;

@Mod.EventBusSubscriber({Dist.CLIENT})
public class CabinFeverHudOverlay {
	@SubscribeEvent(priority = EventPriority.NORMAL)
	public static void eventHandler(RenderGuiEvent.Pre event) {
		int w = event.getWindow().getGuiScaledWidth();
		int h = event.getWindow().getGuiScaledHeight();
		Level world = null;
		double x = 0;
		double y = 0;
		double z = 0;
		Player entity = Minecraft.getInstance().player;
		if (entity != null) {
			world = entity.level;
			x = entity.getX();
			y = entity.getY();
			z = entity.getZ();
		}
		RenderSystem.disableDepthTest();
		RenderSystem.depthMask(false);
		RenderSystem.enableBlend();
		RenderSystem.setShader(GameRenderer::getPositionTexShader);
		RenderSystem.blendFuncSeparate(GlStateManager.SourceFactor.SRC_ALPHA, GlStateManager.DestFactor.ONE_MINUS_SRC_ALPHA, GlStateManager.SourceFactor.ONE, GlStateManager.DestFactor.ZERO);
		RenderSystem.setShaderColor(1, 1, 1, 1);
		if (CabinFeverHudShouldDisplayProcedure.execute(entity)) {
			if (CabinFeverHudShouldDisplayProcedure.execute(entity)) {
				RenderSystem.setShaderTexture(0, new ResourceLocation("cabin_fever:textures/screens/cabinfeverrisk.png"));
				Minecraft.getInstance().gui.blit(event.getPoseStack(), 3, h - 12, 0, 0, 10, 10, 10, 10);
			}
			if (CabinFeverHudIncreaseArrowProcedure.execute(entity)) {
				RenderSystem.setShaderTexture(0, new ResourceLocation("cabin_fever:textures/screens/arrowup.png"));
				Minecraft.getInstance().gui.blit(event.getPoseStack(), 8, h - 16, 0, 0, 7, 9, 7, 9);
			}
			if (CabinFeverHudDecreaseArrowProcedure.execute(entity)) {
				RenderSystem.setShaderTexture(0, new ResourceLocation("cabin_fever:textures/screens/arrowdown.png"));
				Minecraft.getInstance().gui.blit(event.getPoseStack(), 8, h - 9, 0, 0, 7, 9, 7, 9);
			}
			if (CabinFeverHudShouldDisplayProcedure.execute(entity))
				Minecraft.getInstance().font.draw(event.getPoseStack(),

						CabinFeverHudMeterTextProcedure.execute(entity), 16, h - 11, -1);
		}
		RenderSystem.depthMask(true);
		RenderSystem.defaultBlendFunc();
		RenderSystem.enableDepthTest();
		RenderSystem.disableBlend();
		RenderSystem.setShaderColor(1, 1, 1, 1);
	}
}
